"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const graphql_1 = require("graphql");
const filesystem_1 = require("../helpers/filesystem");
exports.defaultPrintSchemaOptions = { commentDescriptions: false };
const generatedSchemaWarning = /* graphql */ `\
# -----------------------------------------------
# !!! THIS FILE WAS GENERATED BY TYPE-GRAPHQL !!!
# !!!   DO NOT MODIFY THIS FILE BY YOURSELF   !!!
# -----------------------------------------------

`;
function emitSchemaDefinitionFileSync(schemaFilePath, schema, options = exports.defaultPrintSchemaOptions) {
    const schemaFileContent = generatedSchemaWarning + graphql_1.printSchema(schema, options);
    filesystem_1.outputFileSync(schemaFilePath, schemaFileContent);
}
exports.emitSchemaDefinitionFileSync = emitSchemaDefinitionFileSync;
function emitSchemaDefinitionFile(schemaFilePath, schema, options = exports.defaultPrintSchemaOptions) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        const schemaFileContent = generatedSchemaWarning + graphql_1.printSchema(schema, options);
        yield filesystem_1.outputFile(schemaFilePath, schemaFileContent);
    });
}
exports.emitSchemaDefinitionFile = emitSchemaDefinitionFile;
